/* Author: 
Daniel czycki www.designsentry.com
*/

jQuery(document).ready(function($) {
	
	/* Color declarations */
	var	accentColor = '#dc0000',
		contrastColor = '#0c0c0c',
		contrastColorLighter1 = '#181818',
		contrastColorLighter2 = '#3A3A3A',
		contrastColorDarker = '#000000',
		contrastColorText1 = '#FAFAFA',
		contrastColorText2 = '#CCCCCC',
		contrastColorText3 = '#808080',
		MainColorDarker1 = '#D0D3D9',
		MainColorDarker2 = '#b8babf',
		MainColorText1 = '#0c0c0c',
		MainColorListHover = '#000000',
		collageShadeMin = 70,
		collageShadeMax = 87;
		
	/* Javascript check, color declarations check */
	$('html').removeClass('no-js').addClass('js');
	var menu = $('#menus');
	contrastColor = hex2rgb(contrastColor);
	if($('html').hasClass('oldie')){contrastColor = 'rgb(255,255,255)';}

	/* // This function is not working in the 1.0 version. There will be an update for it in 1.1. Twitter initiates. Enter your username here.
	$(".twitbox").tweet({
            username: "designsentry",
            join_text: "auto",
            avatar_size: 0,
            count: 1,
            auto_join_text_default: "",
            auto_join_text_ed: "",
            auto_join_text_ing: "",
            auto_join_text_reply: "ds replied to",
            auto_join_text_url: "ds was checking out",
            loading_text: "loading tweets..."
    }); */
	
	/* The menus dropdown rolldown script */
	menu.find('li:has(ul)').addClass('hassubmenu');
	menu.find('li').hover(function(){
		$(this).find('>a').children(':last').animate({color:contrastColorText1},{queue:false,duration:300});
		$('>a',this).css({borderBottomColor: accentColor,color: contrastColorText1});
	},function(){
		$(this).find('>a').children(':last').animate({color:contrastColorText3},{queue:false,duration:300});
		$('>a',this).animate({borderBottomColor: contrastColorLighter2,color: contrastColorText2},{queue:false,duration:100});
	});
	menu.find('li').hoverIntent({
	over: makeTall, 
	timeout: 200,
	sensitivity: 30,
	out: makeShort
	});
	function makeTall(){
		$(this).has('ul').addClass('current-hover').find('ul:first').slideDown({queue:false,duration:220});
		var availableSpace = $(window).width() - $(this).offset().left;
		if(availableSpace < 520){
			$(this).find('ul').find('li').find('ul').css({left: '-264px'});
		}
	}
	function makeShort(){ $(this).has('ul').removeClass('current-hover').find('ul:first').fadeOut({queue:false,duration:200});}
	
	/* The zone highlights for posts in blog (black bars turn red/color when they appear on the viewed space) */
	var zoneSizeMin = $(window).height()*0.1,
		zoneSizeMax = $(window).height()*0.9;
	$(document).scroll(function(){
		$('.thedash').each(function(){
			var elePosition = $(this).offset().top - $(document).scrollTop();
			if( elePosition < zoneSizeMax && elePosition > zoneSizeMin){
				$(this).animate({borderColor: accentColor},{queue:false,duration:400});
			}
			else if(elePosition < zoneSizeMin || elePosition > zoneSizeMax){
				$(this).animate({borderColor: '#2b2b2b'},{queue:false,duration:400});
			}
		});
	});
	
	/* Icons hover effect */
	$('ul.icons').find('li').add('.zoomer img').hover(function(){
		$(this).animate({opacity: 0.5},{queue:false,duration:250});
	},function(){
		$(this).animate({opacity: 1},{queue:false,duration:250});
	});
	$('#footer').find('.widget').find('ul:not(.icons)').find('li').hover(function(){
		$(this).find('a').css({borderColor: accentColor,color: contrastColorText1});
	},function(){
		$(this).find('a').animate({borderColor: contrastColorLighter2,color: contrastColorText2},{queue:false,duration:100});
	});
	$('#main').find('.widget').find('ul:not(.icons)').find('li').hover(function(){
		$(this).find('a').css({borderColor: accentColor,color: MainColorListHover});
	},function(){
		$(this).find('a').animate({borderColor: MainColorDarker1,color: MainColorText1},{queue:false,duration:100});
	});
	
	/* Newsletter effects (colored borders on focus) */
	var oldBgColor;
	$('#footer').find('.widget').find('form').find('input[type="text"],input[type="submit"]').hover(function(){
		oldBgColor = $(this).css('backgroundColor');
		$(this).animate({borderTopColor: contrastColorLighter2,borderRightColor: contrastColorLighter2,borderBottomColor: accentColor,borderLeftColor: contrastColorLighter2,backgroundColor: contrastColorDarker,color: contrastColorText1},{queue:false,duration:200});
	},function(){
		$(this).animate({borderColor: contrastColorLighter2,backgroundColor: oldBgColor,color: contrastColorText2},{queue:false,duration:200});
	});
	
	/* call for uniform JS, replacing ugly default checkboxes/radios when used */
	$('select,radio').uniform();
	
	/* Contact form validation, ajax response */
    var paraTag = jQuery('input#cf-submit').parent('p');
    jQuery(paraTag).children('input').remove();
    jQuery(paraTag).append('<input type="button" name="submit" id="cf-submit" value="Send it!" class="superbutton" />');

    jQuery('#form_main input#cf-submit').click(function() {
        jQuery('#form_main p').append('<img src="css/img/ajax-loader.gif" class="loaderIcon" alt="Loading..." />');

        var name = jQuery('input#name').val();
        var email = jQuery('input#cf-email').val();
        var phone = jQuery('input#phone').val();
        var comments = jQuery('textarea#comments').val();

        jQuery.ajax({
            type: 'post',
            url: 'sendEmail.php',
            data: 'name=' + name + '&email=' + email + '&phone=' + phone + '&comments=' + comments,

            success: function(results) {
                jQuery('#form_main img.loaderIcon').fadeOut(5000);
                jQuery('ul#form_response').html(results);
            }
        }); // end ajax
    });
	
	/* Search effects on hover and focus */
	$('#main').find('form').find('input[type="text"],input[type="submit"],textarea').hover(function(){
		$(this).animate({borderTopColor: MainColorDarker2,borderRightColor: MainColorDarker2,borderBottomColor: accentColor,borderLeftColor: MainColorDarker2},{queue:false,duration:200});
	},function(){
		$(this).animate({borderColor: MainColorDarker1},{queue:false,duration:200});
	});
	
	/* Collage splitting and loading sequence */
	var isHomepage = false;
	if($('body').hasClass('homepage')){isHomepage = true;}
	var viewWidth = $(window).width(),
	viewMultiplier = Math.round((viewWidth)/320),
	howManyItems = $('#collage').find('li').size(),
	howManyRows = Math.ceil(howManyItems/viewMultiplier),
	totalPicsDisplayed = howManyRows*viewMultiplier,
	properWidth = Math.round(viewWidth/viewMultiplier),
	howManyToFill = ((howManyRows)*viewMultiplier)-howManyItems;
	$('#collage').find('li').each(function(){
		var data_img = $(this).attr('data-img'),
			data_desc = $(this).attr('data-description');
		$(this).find('a').append('<img src="'+data_img+'" /><h5>'+data_desc+'</h5>');
	});
	if(isHomepage){
		if(properWidth > 318){viewMultiplier = viewMultiplier+1, totalPicsDisplayed = 3*viewMultiplier, properWidth = Math.round(viewWidth/viewMultiplier);}
		if(viewWidth < 1024){viewMultiplier = 3, totalPicsDisplayed = 9, properWidth = 318;}
		$('#collage').css({width:properWidth*viewMultiplier}).find('li').css({display:'none'}).slice(0,3*viewMultiplier).css({width:properWidth,display:'block'}).each(function(){
			var light = $.randomBetween(collageShadeMin, collageShadeMax),
				color = contrastColor.replace(/[^0-9,]+/g, ""),
				red = color.split(",")[0],
				gre = color.split(",")[1],
				blu = color.split(",")[2],
				hsv = RgbToHsv(red,gre,blu),
				rgb = HsvToRgb(hsv.h, hsv.s, light);
			color = 'rgb(' + rgb.r + ',' + rgb.g + ',' + rgb.b + ')';
			$(this).css({backgroundColor: color});
		});
	}else{
	if(howManyToFill > 0){for (i = 0; i < howManyToFill; i++) {$('#collage').append('<li><img src="images/collage/blank.png" alt="" /></li>');}}
		if(properWidth > 318){viewMultiplier = viewMultiplier+1, totalPicsDisplayed = howManyRows*viewMultiplier, properWidth = Math.round(viewWidth/viewMultiplier);}
		$('#collage').css({width:properWidth*viewMultiplier}).find('li').css({display:'none'}).slice(0,totalPicsDisplayed).css({width:properWidth,display:'block'}).each(function(){
			var light = $.randomBetween(4, 15),
				color = contrastColor.replace(/[^0-9,]+/g, ""),
				red = color.split(",")[0],
				gre = color.split(",")[1],
				blu = color.split(",")[2],
				hsv = RgbToHsv(red,gre,blu),
				rgb = HsvToRgb(hsv.h, hsv.s, light);
			color = 'rgb(' + rgb.r + ',' + rgb.g + ',' + rgb.b + ')';
			$(this).css({backgroundColor: color});
		});
	}
	
	$('#collage').find('li').slice(0,totalPicsDisplayed).find('img').one('load',function(){
		var randomTimeOut = $.randomBetween(0, 1800),
			$this = $(this),
			randomFadeIn = $.randomBetween(800,1800),
			colorImageUrl = this.src.replace('_bw','_col'),
			out = setTimeout(function(){$this.addClass('done'); clearTimeout(out);}, randomTimeOut+randomFadeIn);	
		$this.css({display:'block'}).hide();
		$this.delay(randomTimeOut).fadeIn(randomFadeIn);
		$this.parent().append('<img class="secondaryimg" style="display:none;" src="'+colorImageUrl+'" />');
	}).each(function(){
		if(this.complete) $(this).load();
	});
	
	$('#collage').find('li:has(a)').hover(function(){
		if($(this).find('img:first-child').hasClass('done')){
			$(this).find('img:first-child').animate({opacity: 0.01},{queue:true,duration:200}).end().find('img:last-child,h5').show();
		}
	},function(){
		if($(this).find('img:first-child').hasClass('done')){
			$(this).find('img:first-child').animate({opacity: 1},{queue:true,duration:200});
		}
	});
	
	/* Clear input on focus in fields */
	$('input[type=text]').each(function(){
	var inputfieldval = $(this).val();
		$(this).focus(function(){
			if(inputfieldval==$(this).val()){
				$(this).val('');
			}
		});
		$(this).blur(function(){
			if($(this).val()==''){
				$(this).val(inputfieldval);
			}
		});
	});
	
	/* Toggler */
	jQuery('div.toggler:not(.open)').hide();
	jQuery('.toggle').click(function(){
		jQuery(this).toggleClass("active").next().slideToggle("fast");
	});
	
	/* Tabber */
	jQuery('.ds_tabber_wrap,.ds_vtabber_wrap').each(function(){
	var tabContainers = jQuery(this).find('.ds_tabber');
	var tabSelectors = jQuery(this).find('.tabber li');
    tabContainers.hide();
    jQuery(this).find('ul.tabber li a').click(function(){
        tabContainers.hide().filter(this.hash).fadeIn(500);
        tabSelectors.removeClass('selected');
        jQuery(this).parent().addClass('selected');
        return false;
    });
	jQuery(this).find('ul.tabber li a:first').click();
	});
	
	/* Pricing Table */
	var pricingcolumn = jQuery('.pricing_column');
	pricingcolumn.hover(function(){
		jQuery(this).find('.pricing_blurb').animate({top: '4px'},200);
	},function(){
		jQuery(this).find('.pricing_blurb').animate({top: '0px'},200);
	});
	
	/* Set the pricing tables to the proper size */
	var pricingrowselector = jQuery('.pricing');
	pricingrowselector.each(function(){
		var numberofcolumns = jQuery(this).find('.pricing_column').length;
		var widthofrow = jQuery(this).parent().width();
		var finalresult = (11 + Math.floor(((widthofrow-2) - (numberofcolumns * (168)))/(numberofcolumns * 2)));
		jQuery(this).find('.pricing_blurb').css({marginLeft: finalresult,marginRight: finalresult});
	});
	
	/* previous onload */
	var fullScreenModeEngaged = false,
	vegasPaused = false;

	/* extending footer */
	var bodyHeight = $('body').height(),
		windowHeight = $(window).height(),
		menu = $('#menus'),
		menuli = menu.find('li').find('a'),
		docHeight = $(document).height();
	if((!$('#slider')&&(windowHeight > bodyHeight))){
		var currentFootHeight = $('#footer').height(),
			newFooterHeight = currentFootHeight + windowHeight - bodyHeight;
		$('#footer').css({height: newFooterHeight});
	}
	
	/* Preserve menu items widths when animating */
	listWidth = $.map($('#menus > li > a'),function(val){return $(val).width();});
	$.each(listWidth,function(key, value){$('#menus > li:nth-child(' + (key+1) + ') > a').css({minWidth: value});});
	
	/* Menus rollupdowns */
	function menuRollUp(){
		menuli.find('span:last-child').add('#logo').delay(100).animate({opacity: 0.01},{queue:true,duration:200}).hide(200);
		$("#menuswrap").delay(300).animate({height: "28px"},{queue:true,duration:400}).find(menu).delay(300).animate({bottom:"6px"},{queue:true,duration:400});
		menuli.delay(300).animate({paddingBottom: "1px",paddingTop: "1px"},{queue:true,duration:200});
		menuli.delay(200).animate({minWidth: "0px"},{queue:true,duration:300});
		menu.removeClass('default').addClass('fixed').find('li').find('ul').hide();
	}
	function menuRollDown(){
		$.each(listWidth,function(key, value){menu.find('> li:nth-child(' + (key+1) + ') > a').css({maxWidth:value}).animate({minWidth:value},{queue:true,duration:170});});
		menuli.delay(300).animate({paddingBottom: "4px",paddingTop: "4px"},{queue:true,duration:200});
		$("#menuswrap").delay(350).animate({height: "147px"},{queue:true,duration:300}).find("ul#menus").delay(400).animate({bottom:"23px"},{queue:true,duration:200});
		menuli.find('span:last-child').add('#logo').delay(350).show(250).animate({opacity: 1},{queue:true,duration:500});
		menu.removeClass('fixed').addClass('default').find('li').find('ul').hide();
	}
	
	/* Menus start */
	if(docHeight > windowHeight*1.5 && viewWidth > 1024){
		$('#header').addClass('supermenu');
	var entertainer = $('#entertainerwrap'),
		entertainerHeight = 0,
		pos = menu.offset();
	if(entertainer.length > 0){entertainerHeight = entertainer.height() - Math.round(entertainer.height()*0.6);}
	$(window).scroll(function(){
		if($(this).scrollTop() > pos.top+menu.height()+entertainerHeight && menu.hasClass('default')){
			menuRollUp();
		}
		else if($(this).scrollTop() <= pos.top && menu.hasClass('fixed') && fullScreenModeEngaged == false){
			menuRollDown();
		}
	});
	}
	
	/* EVG+BBQ Portfolio*/
	if($('body').hasClass('homepage') || $('body').hasClass('portfolio')){
  var cache = {
    '': $('')
  };	
  $(window).bind( 'hashchange', function(e) {
    var url = $.param.fragment();
    if ( cache[ url ] ) {
		$('#container').find('.closebutton').find('a').click();
    } else {
		fullScreenModeEngaged = true;
		menuRollUp();
		$('#entertainerwrap,#footerwrap,#mainwrap').fadeOut(500);
		//$('#header').animate({opacity:0.8},{queue:true,duration:400});
		$.ajax({
			url: url,
			type: 'post',
			data: {},
			async: true,
			cache: false,
			beforeSend:function(){
			},
			success: function(data){
				ahlsEV = $(data);
				$('#container').append(ahlsEV).find('.portfolioitemwrap,.portfolionavi,.closebutton').hide().delay(300).fadeIn(1000);
				$('.innerinfohead').jScrollPane({autoReinitialise:true,autoReinitialiseDelay:500});
				$('body').append('<div id="HAL"><div class="insides" /><p>loading..</p></div>');
				$('#HAL').fadeIn({queue:false,duration:6000});
				var backgroundsArray = [];
				$(data).imagesLoaded(function(){
					supportClasses = $('.portfolioitemwrap,.portfolionavi,.closebutton');
					$('#HAL').fadeOut({queue:false,duration:400});
					$('#container').find('.backgroundimages').find('img').each(function(){
						backgroundsArray.push({'src':this.src});
					});
					$.vegas('slideshow',{
						delay:5000,
						loading:false,
						backgrounds:backgroundsArray
					});
					setTimeout(function(){
						if($('#container').find('.pinfohead').length && viewWidth > 1024){
							portfolioDescriptionRollOut();
							$('#container').find('.showhide').fadeIn({queue:true,duration:300});
						}
					},1500)
					$('#container').find('.pnext').find('a').click(function(){
						$.vegas('next');
						$.vegas('pause');
						vegasPaused = true;
						return false;
					});
					$('#container').find('.pprev').find('a').click(function(){
						$.vegas('previous');
						$.vegas('pause');
						vegasPaused = true;
						return false;
					});
					$('#container').find('.closebutton').find('a').click(function(){
						menuRollDown();
						fullScreenModeEngaged = false;
						$('#entertainerwrap,#footerwrap,#mainwrap').delay(500).fadeIn(500);
						supportClasses.delay(100).fadeOut(500, function() { $(this).remove(); });
						$.vegas('stop');
						setTimeout(function(){
							$.vegas('destroy');
							$('#container').find('.backgroundimages').add('#HAL').remove();
						},1000);
					});
					$('#container').find('.showhide').find('a').toggle(function(){
						portfolioDescriptionRollIn();
					},function(){
						portfolioDescriptionRollOut();
					});
				});
			},
			error:function(){
			}
		});
    }
  });
  }
  
	/* Portfolio helper functions */
	function portfolioDescriptionRollOut(){
		$('#container').find('.closebutton').animate({left: "86px"},{queue:false,duration:300});
		$('#container').find('.portfolionavi').animate({left: "638px"},{queue:false,duration:300});
		$('#container').find('.showhide').removeClass('showhideretracted').animate({left: "193px",width: "49px",backgroundPosition:"(1px 1px)"},{queue:false,duration:300});
		$('#container').find('.pinfohead').fadeIn({queue:true,duration:300});
	}
	function portfolioDescriptionRollIn(){
		$('#container').find('.closebutton').animate({left: "0px"},{queue:false,duration:300});
		$('#container').find('.portfolionavi').animate({left: "107px"},{queue:false,duration:300});
		$('#container').find('.showhide').addClass('showhideretracted').animate({left: "0px",width: "192px",backgroundPosition:"(-102px 1px)"},{queue:false,duration:300});
		$('#container').find('.pinfohead').fadeOut({queue:true,duration:300});
	}
	if($('#collage')){
		$(document).keypress(function(e){
			if (e.keyCode == 37) { 
				$.vegas('previous');
				$.vegas('pause');
				vegasPaused = true;
				return false;
			}
		});
		$(document).keypress(function(e){
			if (e.keyCode == 39) { 
				$.vegas('next');
				$.vegas('pause');
				vegasPaused = true;
				return false;
			}
		});
		$(document).keydown(function(e){
			if (e.keyCode == 32) {
				if(vegasPaused == true){
					vegasPaused = false;
					$.vegas('slideshow');
				}
				else{
					vegasPaused = true;
					$.vegas('pause');
					return false;
				}
			}
		});
		$(document).keypress(function(e){
			if (e.keyCode == 40) { 
				portfolioDescriptionRollIn();
			}
		});
		$(document).keypress(function(e){
			if (e.keyCode == 38 && $('#container').find('.pinfohead').length) { 
				portfolioDescriptionRollOut();
			}
		});
	}
  
  // Since the event is only triggered when the hash changes, we need to trigger
  // the event now, to handle the hash the page may have loaded with.
  $(window).trigger( 'hashchange' );
  
  
});
/* End of onstart functions */
	
	
/* Start of functions initialized after full load of page */
jQuery(window).load(function(){

	/* Nivo Slider load for wide slider templates and normal slider template */
	$('#slider').nivoSlider({
        effect: 'random', // Specify sets like: 'fold,fade,sliceDown'
        slices: 10, // For slice animations
        boxCols: 8, // For box animations
        boxRows: 4, // For box animations
        animSpeed: 700, // Slide transition speed
        pauseTime: 9000, // How long each slide will show
        startSlide: 0, // Set starting Slide (0 index)
        directionNav: true, // Next & Prev navigation
        directionNavHide: true, // Only show on hover
        controlNav: true, // 1,2,3... navigation
        controlNavThumbs: false, // Use thumbnails for Control Nav
        pauseOnHover: true, // Stop animation while hovering
        manualAdvance: false, // Force manual transitions
        prevText: 'Prev', // Prev directionNav text
        nextText: 'Next', // Next directionNav text
        randomStart: false, // Start on a random slide
        beforeChange: function(){}, // Triggers before a slide transition
        afterChange: function(){}, // Triggers after a slide transition
        slideshowEnd: function(){}, // Triggers after all slides have been shown
        lastSlide: function(){}, // Triggers when last slide is shown
        afterLoad: function(){} // Triggers when slider has loaded
    });

	
	/* extending footer for slider page */
	var currentFootHeight = $('#footer').height(),
		bodyHeight = $('body').height(),
		windowHeight = $(window).height();
	if(($('#slider'))&&(windowHeight > bodyHeight)){
		newFooterHeight = newFooterHeight = currentFootHeight + windowHeight - bodyHeight;
		$('#footer').css({height: newFooterHeight});
	}
	
	/* prettyPhoto Lightbox */
	jQuery("a[rel^='prettyPhoto']").add('.ds_zoomer_pic').prettyPhoto({
		animation_speed: 'fast',
		slideshow: 5000,
		autoplay_slideshow: false,
		show_title: true,
		allow_resize: true,
		default_width: 500,
		default_height: 344,
		theme: 'dark_rounded', /* light_rounded / dark_rounded / light_square / dark_square / facebook */
		overlay_gallery: true,
		social_tools: false /* for social icons un-comment this: '<div class="pp_social"><div class="twitter"><a href="http://twitter.com/share" class="twitter-share-button" data-count="none">Tweet</a><script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script></div><div class="facebook"><iframe src="http://www.facebook.com/plugins/like.php?locale=en_US&href='+location.href+'&amp;layout=button_count&amp;show_faces=true&amp;width=500&amp;action=like&amp;font&amp;colorscheme=light&amp;height=23" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:500px; height:23px;" allowTransparency="true"></iframe></div></div>' */
	});
	
});